Index: documentation/trunk/tutorials/xml-source/tutorial_en.xml
===================================================================
--- documentation/trunk/tutorials/xml-source/tutorial_en.xml	(revision 26030)
+++ documentation/trunk/tutorials/xml-source/tutorial_en.xml	(revision 26032)
@@ -1487,6 +1487,6 @@
 </NumberedItem>
 <NumberedItem>
-<Text id="assoc-files-12">If you're working with structured Word documents that contain formatted headings and you want better structured and formatted HTML versions of the documents to be generated by Greenstone from the Word format, optionally set the <Format>windows_scripting</Format> option for the <AutoText text="WordPlugin"/> if building on Windows, or turn on the <Format>open_office_scripting</Format> option if this extension has been added to your Greenstone installation and either OpenOffice or LibreOffice is available on your system.</Text>
-<Text id="assoc-files-13">Optionally set the <AutoText text="level1_heading" type="italics"/> to <i>heading\s*1</i>, or whatever is appropriate for your documents if they use style information for headings that deviate from the norm for Word. Repeat as is needed for <AutoText text="level2_heading" type="italics"/> and so forth. For more details on how to control sections within a Word document, see the <TutorialRef id="enhanced_word"/> tutorial.</Text>
+<Text id="assoc-files-12">If you're working with structured Word documents that contain formatted headings and you want better structured and formatted HTML versions of the documents to be generated by Greenstone from the Word format, optionally set the <Format>windows_scripting</Format> option for the <AutoText text="WordPlugin"/> if building on Windows. Alternatively, you can turn on the <Format>open_office_scripting</Format> option if this extension has been added to your Greenstone installation and if either OpenOffice or LibreOffice is available on your system.</Text>
+<Text id="assoc-files-13">If you're using windows scripting, optionally set the <AutoText text="level1_heading" type="italics"/> to <i>heading\s*1</i>, or whatever is appropriate for your documents if they use style information for headings that deviate from the norm for Word. Repeat as is needed for <AutoText text="level2_heading" type="italics"/> and so forth. For more details on how to control sections within a Word document, see the <TutorialRef id="enhanced_word"/> tutorial.</Text>
 </NumberedItem>
 <NumberedItem>
@@ -1495,11 +1495,18 @@
 <NumberedItem>
 <Text id="assoc-files-15">Building the collection at this point will have the effect that internally Greenstone will have captured this relationship between the different file versions of the same documents; however, until we make some adjustments to the format statements, none of this will be visible to the end-user. The collection built at this point (with default settings) allows a user to search the text from the Word document, browse by title metadata and so on, but when it comes to the point of viewing a document there will only be the choice of viewing the Word version of the document, or the HTML version that Greenstone automatically generates by processing the Word document.</Text>
-<Text id="assoc-files-16">To go beyond this, the key change to make is to alter the part of default VList statement that says:</Text>
-<Format><td valign="top">[ex.srclink]{Or}{[ex.thumbicon],[ex.srcicon]}[ex./srclink]</td></Format>
+<Text id="assoc-files-16">To go beyond this, the key change to make is to alter the part of the <MajorVersion number="2">default VList statement that says:</MajorVersion><MajorVersion number="3">documentNode template of the <AutoText text="browse"/> format statement which chooses between <Format>thumbicon</Format> and <Format>srcicon</Format>, and replace this with a reference to <Format>equivDocIcon</Format> instead.</MajorVersion></Text>
+<MajorVersion number="2">
+<Format>
+<td valign="top">[ex.srclink]{Or}{[ex.thumbicon],[ex.srcicon]}[ex./srclink]</td>
+</Format>
 <Text id="assoc-files-18">to:</Text>
-<Format><td valign="top">[ex.equivDocLink][ex.equivDocIcon][ex./equivDocLink]</td></Format>
-<Text id="assoc-files-19">Two things occur in this edit. The main difference is the switch from using <AutoText text="ex.srclink" type="italics"/> and <AutoText text="ex.srcicon" type="italics"/> that provides the link to the primary source document (which is the Word document), and replace it with a hyperlink around an icon to the document that Greenstone has associated as an equivalent document (which is the PDF version). The icon Greenstone chooses to show is based on the filename extension of the matching file it has found. In this case <img src="../tutorial_files/ipdf.gif"/>.</Text>
-<Text id="assoc-files-20">The second (more minor) change in this edit is to simplify the statement a bit. The original uses an <Format>{Or}</Format> statement to show a thumbnail version of the document if Greenstone has one, in preference over the source icon. Since in this collection we have no thumbnails generated, it has been simplified by eliminating the <Format>{Or}</Format> combination and going straight to the <AutoText text="ex.equivDocIcon" type="italics"/> metadata item.</Text>
-<Text id="assoc-files-21">Switch to the <AutoText key="glidict::GUI.Format"/> panel and edit the format statement for VList (All).</Text>
+<Format>
+<td valign="top">[ex.equivDocLink][ex.equivDocIcon][ex./equivDocLink]</td>
+</Format>
+</MajorVersion>
+<Text id="assoc-files-19">Two things occur in this replacement. The main difference is the switch from using <AutoText text="ex.srclink" type="italics"/> and <AutoText text="ex.srcicon" type="italics"/> that provides the link to the primary source document (which is the Word document), and replace it with a hyperlink around an icon to the document that Greenstone has associated as an equivalent document (which is the PDF version). The icon Greenstone chooses to show is based on the filename extension of the matching file it has found. In this case <img src="../tutorial_files/ipdf.gif"/>.</Text>
+<MajorVersion number="2">
+<Text id="assoc-files-20">The second (more minor) change in this edit is to simplify the statement a bit. The original uses an <Format>{Or}</Format> statement to show a thumbnail version of the document, if Greenstone has one, in preference over the source icon. Since in this collection we have no thumbnails generated, it has been simplified by eliminating the <Format>{Or}</Format> combination and going straight to the <AutoText text="ex.equivDocIcon" type="italics"/> metadata item.</Text>
+<Text id="assoc-files-21">To make the change then, switch to the <AutoText key="glidict::GUI.Format"/> panel and edit the format statement for VList (All).</Text>
 <Text id="assoc-files-22">Change:</Text>
 <Format>
@@ -1519,4 +1526,77 @@
  [/highlight]{If}{[dc.Creator],: [sibling(All'\, '):dc.Creator]}</td><br />
 </Format> 
+</MajorVersion>
+<MajorVersion number="3">
+<Text id="assoc-files-20-3">The second (more minor) change in this edit is to simplify the statement a bit. The original uses a <Format>&lt;gsf:choose-metadata/&gt;</Format> statement to show a thumbnail version of the document, if Greenstone has one, in preference over the source icon. Since in this collection we have no thumbnails generated, it has been simplified by eliminating the <Format>&lt;gsf:choose-metadata/&gt;</Format> combination and going straight to the <AutoText text="ex.equivDocIcon" type="italics"/> metadata item.</Text>
+<Text id="assoc-files-21-3">To make the change then, switch to the <AutoText key="glidict::GUI.Format"/> panel and edit the documentNode template of the <AutoText text="browse"/> format statement</Text>
+<table>
+<th>
+<td><Text id="assoc-files-22"><b>Change:</b></Text></td>
+<td><Text id="assoc-files-23"><b>To:</b></Text></td>
+</th>
+<tr>
+<td valign="bottom">
+<Format>
+&lt;td valign=&quot;top&quot;&gt;<br />
+  <Tab n="1"/>&lt;gsf:link type=&quot;source&quot;&gt;<br />
+    <Tab n="2"/>&lt;gsf:choose-metadata&gt;<br />
+      <Tab n="3"/>&lt;gsf:metadata name=&quot;thumbicon&quot;/&gt;<br />
+      <Tab n="3"/>&lt;gsf:metadata name=&quot;srcicon&quot;/&gt;<br />
+    <Tab n="2"/>&lt;/gsf:choose-metadata&gt;<br />
+  <Tab n="1"/>&lt;/gsf:link&gt;<br />
+&lt;/td&gt;<br />
+&lt;td valign=&quot;top&quot;&gt;<br />
+  <Tab n="1"/>&lt;gsf:link type=&quot;document&quot;&gt;<br />
+    <Tab n="2"/>&lt;gsf:choose-metadata&gt;<br />
+      <Tab n="3"/>&lt;gsf:metadata name=&quot;dc.Title&quot;/&gt;<br />
+      <Tab n="3"/>&lt;gsf:metadata name=&quot;exp.Title&quot;/&gt;<br />
+      <Tab n="3"/>&lt;gsf:metadata name=&quot;ex.dc.Title&quot;/&gt;<br />
+      <Tab n="3"/>&lt;gsf:metadata name=&quot;Title&quot;/&gt;<br />
+      <Tab n="3"/>&lt;gsf:default&gt;Untitled&lt;/gsf:default&gt;<br />
+    <Tab n="2"/>&lt;/gsf:choose-metadata&gt;<br />
+  <Tab n="1"/>&lt;/gsf:link&gt;<br />
+  <Tab n="1"/>&lt;gsf:switch&gt;<br />
+    <Tab n="2"/>&lt;gsf:metadata name=&quot;Source&quot;/&gt;<br />
+    <Tab n="2"/>&lt;gsf:when test=&quot;exists&quot;&gt;<br />
+      <Tab n="3"/>&lt;br/&gt;&lt;i&gt;(&lt;gsf:metadata name=&quot;Source&quot;/&gt;)&lt;/i&gt;<br />
+    <Tab n="2"/>&lt;/gsf:when&gt;<br />
+  <Tab n="1"/>&lt;/gsf:switch&gt;<br />
+&lt;/td&gt;
+</Format>
+</td>
+<td valign="bottom">
+<Format>
+&lt;td valign=&quot;top&quot;&gt;<br />
+<highlight>
+  <Tab n="1"/>&lt;gsf:metadata name=&quot;equivDocLink&quot;/&gt;<br />
+  <Tab n="1"/>&lt;gsf:metadata name=&quot;equivDocIcon&quot;/&gt;<br />
+  <Tab n="1"/>&lt;gsf:metadata name=&quot;/equivDocLink&quot;/&gt;
+</highlight><br />
+&lt;/td&gt;<br />
+&lt;td valign=&quot;top&quot;&gt;<br />
+  <Tab n="1"/>&lt;gsf:link type=&quot;document&quot;&gt;<br />
+    <Tab n="2"/>&lt;gsf:choose-metadata&gt;<br />
+      <Tab n="3"/>&lt;gsf:metadata name=&quot;dc.Title&quot;/&gt;<br />
+      <Tab n="3"/>&lt;gsf:metadata name=&quot;exp.Title&quot;/&gt;<br />
+      <Tab n="3"/>&lt;gsf:metadata name=&quot;ex.dc.Title&quot;/&gt;<br />
+      <Tab n="3"/>&lt;gsf:metadata name=&quot;Title&quot;/&gt;<br />
+      <Tab n="3"/>&lt;gsf:default&gt;Untitled&lt;/gsf:default&gt;<br />
+    <Tab n="2"/>&lt;/gsf:choose-metadata&gt;<br />
+  <Tab n="1"/>&lt;/gsf:link&gt;<br /> 
+  <Tab n="1"/>&lt;gsf:switch&gt;
+    <highlight><br />
+    <Tab n="2"/>&lt;gsf:metadata name=&quot;dc.Creator&quot;/&gt;<br />
+    <Tab n="2"/>&lt;gsf:when test=&quot;exists&quot;&gt;<br />
+      <Tab n="3"/>&lt;br/&gt;&lt;gsf:metadata name=&quot;dc.Creator&quot; separator=&quot;, &quot;/&gt;<br />
+    <Tab n="2"/>&lt;/gsf:when&gt;
+  </highlight><br />
+  <Tab n="1"/>&lt;/gsf:switch&gt;<br />
+&lt;/td&gt;
+</Format> 
+</td>
+</tr>
+</table>
+<br />
+</MajorVersion>
 <Text id="assoc-files-24">Note: When Greenstone encounters a file that matches the provided <Format>associate_ext</Format> value (<Format>pdf</Format> in our case), it sets the metadata value <AutoText text="ex.equivDocIcon"/> for that document to be the macro <i>_iconXXX_</i>, where <i>XXX</i> is whatever the filename extension is (so <AutoText text="_iconpdf_" type="italics"/> in our case). As long as there is an existing macro defined for that combination of the word <i>icon</i> and the filename extension, then a suitable icon will be displayed when the document appears in a VList. For <i>pdf</i> the displayed icon will be <img src="../tutorial_files/ipdf.gif"/>.</Text>
 </NumberedItem>