Index: /documentation/trunk/tutorials/xml-source/tutorial_en.xml
===================================================================
--- /documentation/trunk/tutorials/xml-source/tutorial_en.xml	(revision 26034)
+++ /documentation/trunk/tutorials/xml-source/tutorial_en.xml	(revision 26035)
@@ -1023,5 +1023,5 @@
 <MajorVersion number="3">
 <NumberedItem>
-<Text id="fw-18-3-3">Next we modify the document entries in the Creator classifier to display all authors. Back in <AutoText key="glidict::CDM.GUI.Formats"/>, select the <AutoText key="coredm::_Global:labelBrowse_"/> format in the list of assigned formats. Edit the format statement for <b>documentNode</b> after the part where it displays the Title metadata, so that it now additionally contains the new line highlighted below. This will display the dc.Creator metadata.</Text>
+<Text id="fw-18-3-3">Next we modify the document entries in the Creator classifier to display all authors. Back in <AutoText key="glidict::CDM.GUI.Formats"/>, select the <AutoText key="coredm::_Global:labelBrowse_"/> format in the list of assigned formats. Edit the format statement for <AutoText text="documentNode"/> after the part where it displays the Title metadata, so that it now additionally contains the new line highlighted below. This will display the dc.Creator metadata.</Text>
 <Format>
     &lt;td valign=&quot;top&quot;&gt;<br />
@@ -1495,5 +1495,5 @@
 <NumberedItem>
 <Text id="assoc-files-15">Building the collection at this point will have the effect that internally Greenstone will have captured this relationship between the different file versions of the same documents; however, until we make some adjustments to the format statements, none of this will be visible to the end-user. The collection built at this point (with default settings) allows a user to search the text from the Word document, browse by title metadata and so on, but when it comes to the point of viewing a document there will only be the choice of viewing the Word version of the document, or the HTML version that Greenstone automatically generates by processing the Word document.</Text>
-<Text id="assoc-files-16">To go beyond this, the key change to make is to alter the part of the <MajorVersion number="2">default VList statement that says:</MajorVersion><MajorVersion number="3">documentNode template of the <AutoText text="browse"/> format statement which chooses between <Format>thumbicon</Format> and <Format>srcicon</Format>, and replace this with a reference to <Format>equivDocIcon</Format> instead.</MajorVersion></Text>
+<Text id="assoc-files-16">To go beyond this, the key change to make is to alter the part of the <MajorVersion number="2">default VList statement that says:</MajorVersion><MajorVersion number="3"><AutoText text="documentNode"/> template of the <AutoText text="browse"/> format statement which chooses between <Format>thumbicon</Format> and <Format>srcicon</Format>, and replace this with a reference to <Format>equivDocIcon</Format> instead.</MajorVersion></Text>
 <MajorVersion number="2">
 <Format>
@@ -1529,5 +1529,5 @@
 <MajorVersion number="3">
 <Text id="assoc-files-20-3">The second (more minor) change in this edit is to simplify the statement a bit. The original uses a <Format>&lt;gsf:choose-metadata/&gt;</Format> statement to show a thumbnail version of the document, if Greenstone has one, in preference over the source icon. Since in this collection we have no thumbnails generated, it has been simplified by eliminating the <Format>&lt;gsf:choose-metadata/&gt;</Format> combination and going straight to the <AutoText text="ex.equivDocIcon" type="italics"/> metadata item.</Text>
-<Text id="assoc-files-21-3">To make the change then, switch to the <AutoText key="glidict::GUI.Format"/> panel and edit the documentNode template of the <AutoText text="browse"/> format statement</Text>
+<Text id="assoc-files-21-3">To make the change then, switch to the <AutoText key="glidict::GUI.Format"/> panel and edit the <AutoText text="documentNode"/> template of the <AutoText text="browse"/> format statement</Text>
 <table>
 <th>
@@ -2009,11 +2009,26 @@
 http://englishhistory.net/tudor/citizens/...
 </Indent> 
-<Text id="0429">If you have copied over a subfolder previously, delete it and make a fresh copy. Drag the folder in the right-hand side of the <AutoText key="glidict::GUI.Gather"/> panel on to the trash can in the lower right corner. Then obtain a fresh copy of the files by dragging across the <Path>englishhistory.net</Path> folder from the <Path>sample_files &rarr; tudor</Path> folder (or the <AutoText key="glidict::Tree.DownloadedFiles"/> folder if you have done exercise <TutorialRef id="downloading_from_internet"/>) on the left-hand side.</Text>
-</NumberedItem>
-<NumberedItem>
-<Text id="0430">To make use of the new URL metadata, the icon link must be changed to serve up the original URL rather than the copy stored in the digital library. Go to the <AutoText key="glidict::GUI.Format"/> panel, select the <AutoText key="glidict::CDM.GUI.Formats"/> section and edit the <AutoText text="VList" /> format statement by replacing</Text>
+<Text id="0429">If you had copied over a subfolder previously, delete it and make a fresh copy. Drag the folder in the right-hand side of the <AutoText key="glidict::GUI.Gather"/> panel on to the trash can in the lower right corner. Then obtain a fresh copy of the files by dragging across the <Path>englishhistory.net</Path> folder from the <Path>sample_files &rarr; tudor</Path> folder (or the <AutoText key="glidict::Tree.DownloadedFiles"/> folder if you have done exercise <TutorialRef id="downloading_from_internet"/>) on the left-hand side.</Text>
+</NumberedItem>
+<NumberedItem>
+<Text id="0430">To make use of the new URL metadata, the icon link must be changed to serve up the original URL rather than the copy stored in the digital library. Go to the <AutoText key="glidict::GUI.Format"/> panel, select the <AutoText key="glidict::CDM.GUI.Formats"/> section and edit the <MajorVersion number="2"><AutoText text="VList" /></MajorVersion><MajorVersion number="3"><AutoText text="documentNode"/> template of the <AutoText text="browse"/></MajorVersion> format statement by replacing</Text>
+<MajorVersion number="2">
 <Format>[link][icon][/link]</Format>
 <Text id="0431">with</Text>
 <Format>[weblink][webicon][/weblink]</Format>
+</MajorVersion>
+<MajorVersion number="3">
+<Format>
+  &lt;gsf:link type=&quot;document&quot;&gt;<br/>
+    <Tab n="1"/>&lt;gsf:icon type=&quot;document&quot;/&gt;<br/>
+  &lt;/gsf:link&gt;
+</Format>
+<Text id="0431">with</Text>
+<Format>
+  &lt;gsf:metadata name=&quot;weblink&quot;/&gt;<br/>
+  &lt;gsf:metadata name=&quot;webicon&quot;/&gt;<br/>
+  &lt;gsf:metadata name=&quot;/weblink&quot;/&gt;
+</Format>
+</MajorVersion>
 </NumberedItem>
 <NumberedItem>