Index: documentation/trunk/tutorials/xml-source/tutorial_en.xml
===================================================================
--- documentation/trunk/tutorials/xml-source/tutorial_en.xml	(revision 26035)
+++ documentation/trunk/tutorials/xml-source/tutorial_en.xml	(revision 26037)
@@ -1459,5 +1459,5 @@
 <Content>
 <Comment>
-<Text id="assoc-files-1">This tutorial demonstrates how to combine Word and PDF versions of the same document together in Greenstone. As an example, two identical articles about Greenstone are used, one is in PDF format, the other in Word. </Text>
+<Text id="assoc-files-1"><Synopsis>This tutorial demonstrates how to combine different versions of the same document together in Greenstone.</Synopsis> As an example, two identical articles about Greenstone are used, one is in PDF format, the other in Word.</Text>
 </Comment>
 <Comment>
@@ -1611,5 +1611,5 @@
 <Content>
 <Comment>
-<Text id="0404">Greenstone collections can be published on a self-installing CD-ROM/DVD that works on Windows.</Text>
+<Text id="0404"><Synopsis>Greenstone collections can be published on a self-installing CD-ROM/DVD that works on Windows.</Synopsis></Text>
 </Comment>
 <NumberedItem>
@@ -3672,15 +3672,21 @@
 <NumberedItem>
 <Text id="0790c">Type:</Text>
-<Command>setup</Command> 
-<Text id="0790d">to set up the ability to run Greenstone command-line programs. On a Linux or Mac machine, you would type:</Text>
-<Command>source setup.bash</Command> 
-</NumberedItem>
-<NumberedItem>
-<Text id="0790e">Change directory into the folder containing the StoneD collection you built in the last exercise.</Text>
-<Command>cd collect\stoned</Command> 
+<MajorVersion number="2"><Command>setup</Command></MajorVersion>
+<MajorVersion number="3"><Command>gs3-setup</Command></MajorVersion>
+<Text id="0790d">to set up the ability to run Greenstone command-line programs.</Text>
+<Text id="0790e">On a Linux or Mac machine, you would similarly open a terminal, change directory into your Greenstone installation's top-level folder and type:</Text>
+<MajorVersion number="2"><Command>source setup.bash</Command></MajorVersion>
+<MajorVersion number="3"><Command>source gs3-setup.sh</Command></MajorVersion>
+</NumberedItem>
+<NumberedItem>
+<Text id="0790f">Change directory into the folder containing the StoneD collection you built in the last exercise.</Text>
+<MajorVersion number="2"><Command>cd collect\stoned</Command></MajorVersion> 
+<MajorVersion number="3"><Command>cd web\sites\localsite\collect\stoned</Command>
+</MajorVersion> 
 </NumberedItem>
 <NumberedItem>
 <Text id="0792">Run the following command to export the collection using the DSpace import/export format:</Text>
-<Command>perl -S export.pl -saveas DSpace -removeold stoned</Command> 
+<MajorVersion number="2"><Command>perl -S export.pl -saveas DSpace -removeold stoned</Command></MajorVersion>
+<MajorVersion number="3"><Command>perl -S export.pl -saveas DSpace -site localsite -removeold stoned</Command></MajorVersion>
 </NumberedItem>
 <Comment>
@@ -3688,5 +3694,5 @@
 </Comment>
 <NumberedItem>
-<Text id="0794">This command has created a new subfolder, <Path>collect &rarr; stoned &rarr; export</Path>. Use the file browser to explore it. In it are the files needed to ingest this set of documents into DSpace.</Text>
+<Text id="0794">This command has created a new subfolder, <MajorVersion number="2"><Path>collect &rarr; stoned &rarr; export</Path></MajorVersion><MajorVersion number="3"><Path>web &rarr; sites &rarr; localsite &rarr; collect &rarr; stoned &rarr; export</Path></MajorVersion>. Use the file browser to explore it. In it are the files needed to ingest this set of documents into DSpace.</Text>
 </NumberedItem>
 <Comment>
@@ -3708,4 +3714,5 @@
 <Text id="gems-4">Start the Greenstone Editor for Metadata Sets (GEMS)</Text>
 <Text id="gems-5"><Menu>Start &rarr; All Programs &rarr; Greenstone-2.85 &rarr; Metadata Set Editor (GEMS)</Menu></Text>
+<Text id="gems-5a">(If you're on Linux, use a terminal to run the <Command>gli/gems.sh</Command> start-up script.) </Text>
 </NumberedItem>
 <NumberedItem>